SystemOrganization addCategory: #'Xpf-Tests-Client'!
SystemOrganization addCategory: #'Xpf-Tests-ProjectTalk'!
SystemOrganization addCategory: #'Xpf-Tests-Fixtures'!
SystemOrganization addCategory: #'Xpf-Tests-Server'!
SystemOrganization addCategory: #'Xpf-Tests-Server-Rest'!

Object subclass: #XpfTestData
	instanceVariableNames: 'testRoot testProject testUser testUser2 testIteration testIteration2 testStory testTask testTask2 testStory2 testEvent1 testEvent2 testRelease testRelease2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Fixtures'!

!XpfTestData methodsFor: 'initialization' stamp: 'mt 4/15/2010 14:10:38.641'!
initialize

	testRoot := XpfRoot new.
	testUser := XpfUser new
		login: RestTest login;
		userName: 'TestUser';
		password: RestTest password;
		wasOnline: true;
		lastAccess: TimeStamp now.
	testUser2 := XpfUser new
		login: RestTest login2;
		password: RestTest password.
	testProject := XpfProject new title: 'Test Project'.
	testEvent1 := XpfEvent new details: (Dictionary new
				at: 'eventType' put: 'XpaBaseEvent';
				at: 'dateAndTime' put: (DateAndTime now - (Duration days: 1)) asString;
				at: 'producer' put: testUser userName;
				at: 'message' put: 'Test Event';yourself).
	testEvent2 := XpfEvent new details: (Dictionary new
				at: 'eventType' put: 'XpaTestStarted';
				at: 'dateAndTime' put: (DateAndTime now) asString;
				at: 'producer' put: testUser userName;
				at: 'message' put: 'Test Event';
				at: 'testCase' put: 'TestCaseABC';
				at: 'selector' put: 'testMethod';yourself).
	testProject addEvent: (testEvent1).
	testProject addEvent: (testEvent2).
	testRelease := XpfRelease new title: 'Test Release'.
	testRelease2 := XpfRelease new title: 'Test Release2'.
	testIteration := XpfIteration new title: 'Test Iteration'.
	testIteration2 := XpfIteration new title: 'Test Iteration2'.
	testStory := XpfUserStory new title: 'Test UserStory'.
	testStory2 := XpfUserStory new title: 'Test UserStory 2'.
	testTask := XpfTask new
		title: 'Test Task';
		timeEstimated: 12;
		timeActual: 15.
	testTask2 := XpfTask new
		title: 'Test Task 2'.
	testRoot := XpfRoot new.
	testRoot addUser: testUser.
	testRoot addUser: testUser2.
	testRoot addProject: testProject.
	testProject addRelease: testRelease.
	testRelease addIteration: testIteration.
	testIteration addUserStory: testStory.
	XpfIteration new addUserStory: testStory2.
	testStory addTask: testTask.
	testProject addDeveloper: testUser.! !

!XpfTestData methodsFor: 'accessing' stamp: 'FHH 7/9/2009 17:36'!
testEvent1

	^ testEvent1! !

!XpfTestData methodsFor: 'accessing' stamp: 'FHH 7/9/2009 17:36'!
testEvent2

	^ testEvent2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testIteration

	^ testIteration! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:25'!
testIteration2

	^ testIteration2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:25'!
testIteration2: anObject

	testIteration2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testIteration: anObject

	testIteration := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testProject

	^ testProject! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testProject: anObject

	testProject := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'mt 4/15/2010 14:08:43.43'!
testRelease
	^ testRelease! !

!XpfTestData methodsFor: 'accessing' stamp: 'mt 4/15/2010 14:08:49.352'!
testRelease2
	^ testRelease2! !

!XpfTestData methodsFor: 'accessing' stamp: 'mt 4/15/2010 14:08:49.407'!
testRelease2: anObject
	testRelease2 := anObject! !

!XpfTestData methodsFor: 'accessing' stamp: 'mt 4/15/2010 14:08:43.479'!
testRelease: anObject
	testRelease := anObject! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:33'!
testRoot

	^ testRoot! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:33'!
testRoot: anObject

	testRoot := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testStory

	^ testStory! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:59'!
testStory2

	^ testStory2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:59'!
testStory2: anObject

	testStory2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testStory: anObject

	testStory := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testTask

	^ testTask! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:27'!
testTask2

	^ testTask2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 18:27'!
testTask2: anObject

	testTask2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testTask: anObject

	testTask := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser

	^ testUser! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser2

	^ testUser2! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser2: anObject

	testUser2 := anObject.! !

!XpfTestData methodsFor: 'accessing' stamp: 'cs 6/2/2009 16:28'!
testUser: anObject

	testUser := anObject.! !

SwaDialog subclass: #XpfPenetrationTest
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfPenetrationTest class methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:03:34'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 17:33'!
create100Projects

	(1 to: 100)
		do: [:i | self createASmallProject]
		displayingProgress: 'Creating small projects'.! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 17:34'!
create100Users

	(1 to: 100)
		do: [self createAUser]
		displayingProgress: 'Creating users'.! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:44'!
createABigLocalProject

	| project userStory |
	project := XpfRoot production addNewProject: self randomTitleDictionary.
	6 atRandom + 6 timesRepeat: [project addNewIteration: self randomTitleDictionary].
	project iterations do: [:it |
		(10 atRandom to: 32) do: [:i|
			userStory := it addNewUserStory: self randomTitleDictionary.
			userStory positionX: 4000000 atRandom.
			userStory positionY: 4000000 atRandom.
			7 atRandom - 1 timesRepeat: [
				(userStory addNewTask: self randomTitleDictionary)]]
		displayingProgress: 'Adding Userstories'.]
	displayingProgress: 'Adding Iterations'.
	"(4 atRandom to: 8) do: [:i |
		project addDeveloper: self createAUser]."! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 18:22'!
createABigProject

	| project userStory |
	project := self repository addProject: self randomTitleDictionary.
	6 atRandom + 6 timesRepeat: [project addNewIteration: self randomTitleDictionary].
	project iterations do: [:it |
		(10 atRandom to: 32) do: [:i|
			userStory := it addNewUserStory: self randomTitleDictionary.
			userStory positionX: 4000000 atRandom.
			userStory positionY: 4000000 atRandom.
			7 atRandom - 1 timesRepeat: [
				(userStory addNewTask: self randomTitleDictionary) reload]]
		displayingProgress: 'Adding Userstories'.]
	displayingProgress: 'Adding Iterations'.
	"(4 atRandom to: 8) do: [:i |
		project addDeveloper: self createAUser]."! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 18:00'!
createASmallProject

	| project userStory |
	project := self repository addProject: self randomTitleDictionary.
	2 atRandom + 2 timesRepeat: [project addNewIteration: self randomTitleDictionary].
	project iterations do: [:it |
		(4 atRandom to: 8) do: [:i |
			userStory := it addNewUserStory: self randomTitleDictionary.
			userStory positionX: 4000000 atRandom.
			userStory positionY: 4000000 atRandom.
			3 atRandom - 1 timesRepeat: [
				(userStory addNewTask: self randomTitleDictionary) reload]]
		displayingProgress: 'Adding Userstories'.]
	displayingProgress: 'Adding Iterations'.
	project addDeveloper: self repository currentUser.! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 14:25'!
createAUser

	^ (self repository addUser: (Dictionary with: 'login' -> self randomString)) reload! !

!XpfPenetrationTest methodsFor: 'initialization' stamp: 'cs 5/6/2009 13:56'!
createQuitButton

	^ UITheme current 
		newButtonIn: self
		for: self
		getState: nil
		action: #cancel
		arguments: nil
		getEnabled: nil
		label: 'Quit'
		help: 'Close the penetration test'! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 18:31'!
dos

	(1 to: 8192) do: [:i| self createABigProject] displayingProgress: 'Adding Projects'.
	(1 to: 16384) do: [:i| self reloadAllProjects] displayingProgress: 'Reloading Projects'.! !

!XpfPenetrationTest methodsFor: 'initialization' stamp: 'cs 5/15/2009 11:06'!
initializeUserInterface
	
	^ self createCol: { 
		self newButtonFor: self action: #reset getEnabled: nil label: 'Reset' help: ''.
		self newButtonFor: self action: #createAUser getEnabled: nil label: 'Create a User' help: ''.
		self newButtonFor: self  action: #create100Users getEnabled: nil label: 'Creates 100 Users' help: ''.
		self newButtonFor: self  action: #createASmallProject getEnabled: nil label: 'Creates a small Project' help: ''.
		self newButtonFor: self  action: #createABigProject getEnabled: nil label: 'Creates a big Project' help: ''.
		self newButtonFor: self  action: #createABigLocalProject getEnabled: nil label: 'Creates a big Project in localhost' help: ''.
		self newButtonFor: self  action: #create100Projects getEnabled: nil label: 'Creates 100 Projects' help: ''.
		self newButtonFor: self  action: #reloadAllProjectsSingle getEnabled: nil label: 'Loads all Projects from Servers (in 1 request)' help: ''.
		self newButtonFor: self  action: #reloadAllProjects getEnabled: nil label: 'Loads all Projects from Servers (with many requests)' help: ''.
		self newButtonFor: self  action: #updater getEnabled: nil label: 'Reload using Updater' help: ''.
		self newButtonFor: self  action: #dos getEnabled: nil label: 'DoS (creates 8192 big projects and loads them 16384 times)' help: ''.}.! !

!XpfPenetrationTest methodsFor: 'initialization' stamp: 'cs 5/6/2009 14:25'!
initializeWith: aRepository 

	self
		repository: aRepository;
		buttons: {self createQuitButton};
		contentMorph: self initializeUserInterface;
		model: aRepository;
		addGrips;
		title: 'Penetration test'.! !

!XpfPenetrationTest methodsFor: 'helping' stamp: 'cs 5/6/2009 14:13'!
randomString

	^ String streamContents: [:stream |
		32 timesRepeat: [
			stream nextPut:
				'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxzy0123456789' atRandom]]! !

!XpfPenetrationTest methodsFor: 'helping' stamp: 'cs 5/6/2009 14:14'!
randomTitleDictionary

	^ Dictionary with: 'title' -> self randomString! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 14:20'!
reloadAllProjects

	self repository cache do: [:proxy | proxy reload].! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:34'!
reloadAllProjectsSingle

	self repository projects reloadDepth: 5.! !

!XpfPenetrationTest methodsFor: 'accessing' stamp: 'cs 5/6/2009 13:51'!
repository

	^ repository! !

!XpfPenetrationTest methodsFor: 'accessing' stamp: 'cs 5/6/2009 13:51'!
repository: anObject

	repository := anObject.! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:34'!
reset

	self repository users copy do: [:user |
		user = self repository currentUser
			ifFalse: [user delete]].
	self repository projects copy do: [:project | project delete].! !

!XpfPenetrationTest methodsFor: 'tests' stamp: 'cs 5/6/2009 14:20'!
updater

	self repository reload.! !

RestTest subclass: #XpfRestTest
	instanceVariableNames: 'testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server-Rest'!

XpfRestTest subclass: #XpfModelToProxyTest
	instanceVariableNames: 'proxyProject testUser3 proxyUser proxyUser3 proxyIteration1 proxyIteration2 testIteration2 proxyStory cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfModelToProxyTest methodsFor: 'running' stamp: 'cs 6/3/2009 15:51'!
setUp

	| repository |
	super setUp.
	repository := XpfProxyRepository fromString: self class url.
	cache := repository cache.
	proxyProject := repository projects first.
	testUser3 := testData testRoot addNewUser: (Dictionary with: 'login' -> 'unique').
	testData testProject addDeveloper: testUser3.
	proxyUser := repository users detect: [:user | user login = self class login2].
	proxyUser3 := repository users detect: [:user | user login = testUser3 login].
	testIteration2 := XpfIteration new title: 'Test Iteration 2'.
	testData testProject addIteration: testIteration2.
	proxyIteration1 := proxyProject iterations first.
	proxyIteration2 := proxyProject iterations second.
	proxyStory := proxyIteration1 userStories first.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:15'!
testAddTaskToMovedUserStoryByAutomaticRedirect

	| oldRestUri oldTaskCount |
	oldRestUri := testData testStory restUri.
	oldTaskCount := testData testStory tasks size.
	testIteration2 addUserStory: testData testStory.
	self
		should: (cache includesKey: oldRestUri);
		shouldnt: (cache includesKey: testData testStory restUri);
		should: proxyStory restUri = oldRestUri.
	"implicit redirect with the next assertion"
	proxyStory addNewTask: (Dictionary with: 'title' ->'new task').
	self 
		should: testData testStory tasks size = (oldTaskCount + 1);
		should: testData testStory tasks last title = 'new task';
		should: proxyStory tasks size = (oldTaskCount + 1);
		should: proxyStory tasks last title = 'new task'.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:14'!
testDeleteMovedUserStoryByAutomaticRedirect

	| oldUserstoriesCount1 oldUserstoriesCount2 oldRestUri |
	oldRestUri := testData testStory restUri.
	oldUserstoriesCount1 := proxyIteration1 userStories size.
	oldUserstoriesCount2 := proxyIteration2 userStories size.
	testIteration2 addUserStory: testData testStory.
	self
		should: (cache includesKey: oldRestUri);
		shouldnt: (cache includesKey: testData testStory restUri);
		should: oldUserstoriesCount1 = 1;
		should: oldUserstoriesCount2 = 0;
		should: proxyStory restUri = oldRestUri.
	"implicit redirect with the next assertion"
	proxyStory delete.
	self 
		should: testData testStory isDeleted;
		should: proxyStory isDeleted;
		should: proxyIteration1 userStories isEmpty.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:14'!
testEditMovedUserStoryByAutomaticRedirect

	| oldUserstoriesCount1 oldUserstoriesCount2 oldRestUri |
	oldRestUri := testData testStory restUri.
	oldUserstoriesCount1 := proxyIteration1 userStories size.
	oldUserstoriesCount2 := proxyIteration2 userStories size.
	testIteration2 addUserStory: testData testStory.
	self
		should: (cache includesKey: oldRestUri);
		shouldnt: (cache includesKey: testData testStory restUri);
		should: oldUserstoriesCount1 = 1;
		should: oldUserstoriesCount2 = 0;
		should: proxyStory restUri = oldRestUri.
	"implicit redirect with the next assertion"
	proxyStory title: 'new title'.
	self 
		should: testData testStory title = 'new title';
		should: proxyStory title = 'new title'.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:14'!
testReloadAddDeveloper

	| oldDeveloperCount oldProjectCount |
	oldDeveloperCount := proxyProject developers size.
	oldProjectCount := proxyUser projects size.
	testData testProject addDeveloper: testData testUser2.
	self
		should: oldDeveloperCount = 2;
		should: oldProjectCount = 0.
	3 timesRepeat: [proxyProject repository reload].
	self
		should: proxyProject developers size = 3;
		should: proxyUser projects size = 1.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:14'!
testReloadMoveUserStory

	| oldUserstoriesCount1 oldUserstoriesCount2 oldRestUri |
	oldRestUri := testData testStory restUri.
	oldUserstoriesCount1 := proxyIteration1 userStories size.
	oldUserstoriesCount2 := proxyIteration2 userStories size.
	testIteration2 addUserStory: testData testStory.
	self
		should: (cache includesKey: oldRestUri);
		shouldnt: (cache includesKey: testData testStory restUri);
		should: oldUserstoriesCount1 = 1;
		should: oldUserstoriesCount2 = 0.
	proxyStory reload.
	self
		shouldnt: (cache includesKey: oldRestUri);
		should: (cache includesKey: testData testStory restUri);
		should: proxyIteration1 userStories size = 0;
		should: proxyIteration2 userStories size = 1;
		should: proxyIteration2 userStories first id = testData testStory id.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:14'!
testReloadMovedUserStoryByAutomaticRedirect

	| oldUserstoriesCount1 oldUserstoriesCount2 oldRestUri |
	oldRestUri := testData testStory restUri.
	oldUserstoriesCount1 := proxyIteration1 userStories size.
	oldUserstoriesCount2 := proxyIteration2 userStories size.
	testIteration2 addUserStory: testData testStory.
	self
		should: (cache includesKey: oldRestUri);
		shouldnt: (cache includesKey: testData testStory restUri);
		should: oldUserstoriesCount1 = 1;
		should: oldUserstoriesCount2 = 0;
		should: proxyStory restUri = oldRestUri;
		"implicit reload with the next assertion"
		should: (proxyStory iteration = proxyIteration2);
		shouldnt: (cache includesKey: oldRestUri);
		should: (cache includesKey: testData testStory restUri);
		should: proxyIteration1 userStories size = 0;
		should: proxyIteration2 userStories size = 1;
		should: proxyIteration2 userStories first id = testData testStory id;
		should: (cache includesKey: testData testStory restUri);
		should: proxyStory restUri = testData testStory restUri.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:13'!
testReloadRemoveDeveloper

	| oldDeveloperCount oldProjectCount |
	oldDeveloperCount := proxyProject developers size.
	oldProjectCount := proxyUser3 projects size.
	testData testProject removeDeveloper: testUser3.
	self
		should: oldDeveloperCount = 2;
		should: oldProjectCount = 1.
	3 timesRepeat: [proxyProject repository reload].
	self
		should: proxyProject developers size = 1;
		should: proxyUser3 projects size = 0.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:13'!
testReloadTitle

	| oldTitle |
	oldTitle := testData testProject title.
	testData testProject title: 'Wow!!'.
	3 timesRepeat: [proxyProject repository reload].
	self should: proxyProject title = testData testProject title.! !

!XpfModelToProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:13'!
testTitle

	self should: proxyProject title = testData testProject title.
	proxyProject iterations 
		with: testData testProject iterations
		do: [ :proxyIter :realIter | self should: proxyIter title = realIter title ]! !

XpfRestTest subclass: #XpfProxyTest
	instanceVariableNames: 'projectProxy iterationProxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfProxyTest methodsFor: 'running' stamp: 'cs 6/3/2009 15:33'!
setUp

	| factory |
	super setUp.
	factory := XpfProxyRepository fromString: self class url.
	projectProxy := factory projects first.
	iterationProxy := projectProxy iterations first.! !

!XpfProxyTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:11'!
testUpdateOnAdd

	| usCount us |
	usCount := testData testIteration userStories size.
	us := iterationProxy addNewUserStory: (Dictionary with: 'title' -> 'UpdateOnAddTask').
	self
		should: iterationProxy project = projectProxy;
		should: us iteration = iterationProxy;
		should: testData testIteration userStories size = (usCount + 1);
		should: iterationProxy userStories size = (usCount + 1).! !

XpfRestTest subclass: #XpfRestAuthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server-Rest'!

!XpfRestAuthTest methodsFor: 'tests' stamp: 'bs 7/1/2009 09:23'!
protectedResourcePath
	^ 'projects/', testData testProject id asString! !

!XpfRestAuthTest methodsFor: 'tests' stamp: 'bs 7/1/2009 10:19'!
testAuthentication

	"Try to get information about a project via http GET request.
	 Verify this by looking into the database directly."

	| response jsonResult |
	ActiveHand resetLoginAndPassword.
	self should: (self get: 'projects/', testData testProject id asString) 
			responseCode = 401.
			
	ActiveHand login: (self class login2) password: (self class password).
	self should: (self get: 'projects/', testData testProject id asString)
			responseCode = 403.
	
	ActiveHand login: (self class login) password: (self class password).
	self should: (response := self get: 'projects/', testData testProject id asString)
			responseCode = 200.

	jsonResult := Json readFrom: response content readStream.
	
 	self 
		should: testData testProject title = (jsonResult at: 'title');
		should: testData testProject id = (jsonResult at: 'id').! !

!XpfRestAuthTest methodsFor: 'tests' stamp: 'bs 7/1/2009 10:12'!
testUsingCredentialsFromActiveHand

	ActiveHand login: (self class login) password: (self class password).
	self
		should: (self get: self protectedResourcePath) 
			responseCode = 200.! !

XpfRestTest subclass: #XpfRestResourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server-Rest'!

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:06'!
testDeleteOneProject
	"Try to delete a project via http DELETE request. This operation should be idempotent. 
	Verify this by looking into the database directly."

	| projectCount response |
	projectCount := testData testRoot projects size.
	response := self delete: testData testProject restUri.
	
	self 
		should: response responseCode = 200;
		should: testData testRoot projects size = (projectCount - 1);
		shouldnt: (testData testRoot projects anySatisfy: [:aProject| aProject id = testData testProject id]).! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:34'!
testDeleteOneTask
	"Try to delete a task from testProject via http DELETE request.
	 This operation should be idempotent. Verify this by looking into the database directly."

	| taskCount response |
	taskCount := testData testStory tasks size.
	response := self delete: testData testTask restUri.
	
	self
		should: response responseCode = 200;
		should: testData testStory tasks size = (taskCount - 1);
		shouldnt: (testData testStory tasks anySatisfy: [:task| task id = testData testTask id]).! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:07'!
testDeleteOneUser
	"Try to delete a user via http DELETE request. This operation should be idempotent. 
	Verify this by looking into the database directly."

	| userCount response |
	userCount := testData testRoot users size.
	response := self delete: testData testUser restUri.
	
	self 
		should: response responseCode = 200;
		should: testData testRoot users size = (userCount - 1);
		shouldnt: (testData testRoot users anySatisfy: [:aUser| aUser id = testData testUser id]).! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:34'!
testDeleteUserstoryWithThreeTasks
	"Try to delete a userStory from testProject via http DELETE request."

	| response storyCount |
	testData testStory addNewTask: (Dictionary newFrom: {'title' -> 'Test Task 2'}).
	testData testStory addNewTask: (Dictionary newFrom: {'title' -> 'Test Task 3'}).
	storyCount := testData testIteration userStories size.
	response := self delete: testData testStory restUri.
	self
		should: response responseCode = 200;
		should: testData testIteration userStories size = (storyCount - 1);
		should: testData testStory tasks size = 0.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:07'!
testGetAllProjects
	"Try to get a list with rest urls to all projects via http GET request. 
	Verify this by looking into the database directly."

	| response jsonResult restUrl |
	response := self get: 'projects'.	
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	
	self should: testData testRoot projects size = jsonResult size.
	
	testData testRoot projects do: [:project |
		restUrl := project restUri.
		self should: (jsonResult includes: restUrl)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:34'!
testGetAllTasks
	"Try to get a list with rest urls to all tasks of testProject via http GET request.
	 Verify this by looking into the database directly."

	| response restUrl jsonResult|
	response := self get: ('{1}/tasks' format: {testData testStory restUri}).
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self should: testData testStory tasks size = jsonResult size.
	
	testData testStory tasks do: [:task |
		restUrl := task restUri.
		self should: (jsonResult includes: restUrl)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:34'!
testGetAllTasksWithDeleted
	"Try to get a list with rest urls to all tasks of testProject via http GET request.
	 Verify this by looking into the database directly."

	| response restUrl jsonResult|
	testData testTask delete.
	response := self get: ('{1}/tasksWithDeleted' format: {testData testStory restUri}).
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self
		should: testData testStory tasks size = (testData testStory tasksWithDeleted size - 1);
		should: testData testStory tasksWithDeleted size = jsonResult size.
	
	testData testStory tasksWithDeleted do: [:task |
		restUrl := task restUri.
		self should: (jsonResult includes: restUrl)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:06'!
testGetAllUsers
	"Try to get a list with rest urls to all users via http GET request. 
	Verify this by looking into the database directly."

	| response jsonResult restUrl |
	response := self get: 'users'.	
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	
	self should: testData testRoot users size = jsonResult size.
	
	testData testRoot users do: [:user |
		restUrl := user restUri.
		self should: (jsonResult includes: restUrl)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:34'!
testGetDeletedTaskDevelopers
	"Try to get information about the developers of a task from testProject
	 via http GET request. Verify this by looking into the database directly."

	| response jsonResult |
	testData testTask delete.
	response := self get: testData testTask restUri, '/developers'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self should: testData testTask developers size = jsonResult size.
	testData testTask developers do: [:developer |
		self should: (jsonResult includes: developer restUri)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:35'!
testGetOneDeletedTask
	"Try to get information about a task from testProject via http GET request.
	 Verify this by looking into the database directly."

	| response jsonResult |
	testData testTask delete.
	response := self get: testData testTask restUri.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self
		should: testData testTask title = (jsonResult at: 'title');
		should: testData testTask id = (jsonResult at: 'id');
		should: testData testTask timeEstimated = (jsonResult at: 'timeEstimated');
		should: testData testTask timeActual = (jsonResult at: 'timeActual');
		should: testData testTask isDone = (jsonResult at: 'isDone');
		should: (testData testTask userStory restUri = (jsonResult at: 'ref userStory')).! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:35'!
testGetOneProject
	"Try to get information about a project via http GET request.
	 Verify this by looking into the database directly."

	| response jsonResult |	
	response := self get: 'projects/', testData testProject id asString.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	
	self 
		should: testData testProject title = (jsonResult at: 'title');
		should: testData testProject id = (jsonResult at: 'id').! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:35'!
testGetOneProjectDepth2

	| response jsonResult |	
	response := self get: 'projects/', testData testProject id asString, '?depth=2'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	
	self 
		should: testData testProject title = (jsonResult at: 'title');
		should: testData testProject iterations size = (jsonResult at: 'col iterations') size.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:35'!
testGetOneProjectDepth3

	| response jsonResult |	
	response := self get: 'projects/', testData testProject id asString, '?depth=3'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	
	self 
		should: testData testProject title = (jsonResult at: 'title');
		should: testData testProject iterations size = (jsonResult at: 'col iterations') size.
	1 to: testData testProject iterations size do: [:i | 
		self should:
			(testData testProject iterations at: i) title =
			(((jsonResult at: 'col iterations') at: i) at: 'title')]! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:35'!
testGetOneTask
	"Try to get information about a task from testProject via http GET request.
	 Verify this by looking into the database directly."

	| response jsonResult |
	response := self get: testData testTask restUri.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self
		should: testData testTask title = (jsonResult at: 'title');
		should: testData testTask id = (jsonResult at: 'id');
		should: testData testTask timeEstimated = (jsonResult at: 'timeEstimated');
		should: testData testTask timeActual = (jsonResult at: 'timeActual');
		should: testData testTask isDone = (jsonResult at: 'isDone');
		should: testData testTask userStory restUri = (jsonResult at: 'ref userStory').! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:36'!
testGetProjectDevelopers

	| response jsonResult |
	response := self get: testData testProject restUri, '/developers'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self should: testData testProject developers size = jsonResult size.
	testData testProject developers do: [:developer |
		self should: (jsonResult includes: developer restUri)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:36'!
testGetProjectIterations

	| response jsonResult |
	response := self get: testData testProject restUri, '/iterations'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self should: testData testProject iterations size = jsonResult size.
	
	1 to: testData testProject iterations size do: [:index |
		self should: (testData testProject iterations at: index) restUri = (jsonResult at: index)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:36'!
testGetStoryOneDeletedTask

	| response jsonResult response2 jsonResult2 oldTaskCount |
	oldTaskCount := testData testStory tasks size.
	testData testTask delete.
	response := self get: testData testStory restUri, '/tasks'.
	self should: response responseCode = 200.
	response2 := self get: testData testStory restUri, '/tasksWithDeleted'.
	self should: response2 responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	jsonResult2 := Json readFrom: response2 content readStream.
	self
		should: jsonResult size = (oldTaskCount - 1);
		should: jsonResult2 size = oldTaskCount.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:36'!
testGetTaskDevelopers
	"Try to get information about the developers of a task from testProject
	 via http GET request. Verify this by looking into the database directly."

	| response jsonResult |
	response := self get: testData testTask restUri, '/developers'.
	self should: response responseCode = 200.
	
	jsonResult := Json readFrom: response content readStream.
	self should: testData testTask developers size = jsonResult size.
	testData testTask developers do: [:developer |
		self should: (jsonResult includes: developer restUri)].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:07'!
testPostAddProject
	"Try to create a new project via http POST request. Verify this by looking into the database directly."

	| response projectCount newProject |
	projectCount := testData testRoot projects size.
	response := self post: 'projects' content: (self jsonDataFrom: {'title' -> 'new test project'}).

	self should: testData testRoot projects size = (projectCount + 1).

	newProject := testData testRoot projects detect: [:aProject | 
		aProject id = response content asURI pathComponents last asNumber].
	self 
		should: newProject title = 'new test project';
		should: response content = newProject restUri! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:36'!
testPostAddTask
	"Try to create a new task to testProject via http POST request.
	 Verify this by looking into the database directly."
	
	| response tasksCount newTask |
	tasksCount := testData testStory tasks size.
	response := self
		post: ('{1}/tasks' format: {testData testStory restUri})
		content: (self jsonDataFrom: {'title' -> 'new test task'. 'timeEstimated' -> 42}).
	
	self should: response responseCode = 200.
	
	response := response content.
	
	self should: testData testStory tasks size = (tasksCount + 1).
	
	newTask := testData testStory tasks detect:
		[:task | task id = response asURI pathComponents last asNumber].
	
	self
		should: response = newTask restUri;
		should: newTask title = 'new test task';
		should: newTask timeEstimated = 42;
		should: newTask userStory = testData testStory.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:07'!
testPostAddUser
	"Try to create a new user via http POST request. Verify this by looking into the database directly."

	| response userCount newUser |
	userCount := testData testRoot users size.
	response := self
		post: 'users'
		content: (self jsonDataFrom: {'userName' -> 'New User'. 'login' -> 'new.user@email.de'. 'password' -> nil}).

	self should: testData testRoot users size = (userCount + 1).

	newUser := testData testRoot users detect: [:aProject | 
		aProject id = response content asURI pathComponents last asNumber].
	self 
		should: newUser userName = 'New User';
		should: newUser login = 'new.user@email.de';
		should: response content = newUser restUri.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:37'!
testPostAttachDeveloperToProject
	"Try to attach testUser to testProject via http POST request"
	
	| response developersCount |
	developersCount := testData testProject developers size.
	response := self
		post: ('{1}/developers' format: {testData testProject restUri})
		content: ('"{1}"' format: {testData testUser2 restUri}).
	
	self 
		should: response responseCode = 200;
		should: testData testProject developers size = (developersCount + 1);
		should: (testData testProject developers includes: testData testUser2);
		should: response content = testData testUser2 restUri.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:37'!
testPostAttachDeveloperToTask
	"Try to attach testUser to testTask via http POST request.
	 Verify this by looking into the database directly."
	
	| response developersCount |
	developersCount := testData testTask developers size.
	response := self
		post: ('{1}/developers' format: {testData testTask restUri})
		content: ('"{1}"' format: {testData testUser restUri}).
	
	self 
		should: response responseCode = 200;
		should: testData testTask developers size = (developersCount + 1);
		should: (testData testTask developers includes: testData testUser);
		should: response content = testData testUser restUri.! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:07'!
testPutOneProject
	"Try to update information for a project via http PUT request.
	 This operation should be idempotent. Verify this by looking into the database directly."
	
	| projectCount response iterCount developersCount |
	projectCount := testData testRoot projects size.
	iterCount := testData testProject iterations size.
	developersCount := testData testProject developers size.
	
	2 timesRepeat: [	
		response := self
			put: testData testProject restUri
			content: (self jsonDataFrom: {'title' -> 'New Title'}).
			
		self 
			should: response responseCode = 200;
			should: testData testRoot projects size = projectCount;
			should: testData testProject title = 'New Title';
			should: testData testProject iterations size = iterCount;
			should: testData testProject developers size = developersCount].! !

!XpfRestResourceTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:37'!
testPutOneTask
	"Try to update information for a task of testProject via http PUT request.
	 This operation should be idempotent. Verify this by looking into the database directly."
	
	| taskCount response developersCount |
	self flag: #CreateFixtures.
	taskCount := testData testStory tasks size.
	developersCount := testData testTask developers size.
	
	2 timesRepeat: [
		response := self
			put: testData testTask restUri
			content: (self jsonDataFrom: {
				'title' -> 'New Title'.
				'timeEstimated' -> 25.
				'timeActual' -> 50.
				'isDone' -> true}).
			
		self 
			should: response responseCode = 200;
			should: testData testStory tasks size = taskCount;
			should: testData testTask title = 'New Title';
			should: testData testTask timeEstimated = 25;
			should: testData testTask timeActual = 50;
			should: testData testTask userStory = testData testStory;
			should: testData testTask developers size = developersCount;
			should: testData testTask isDone].! !

!XpfRestTest class methodsFor: 'testing' stamp: 'topa 3/5/2009 13:08'!
isAbstract
	
	^ self == XpfRestTest
! !

!XpfRestTest class methodsFor: 'testing' stamp: 'cs 5/22/2009 12:15'!
path

	^ XpfRestResourceHttpHandler pathPattern! !

!XpfRestTest methodsFor: 'running' stamp: 'cs 6/3/2009 14:20'!
setUp

	"Install a handler for http service. Add a test project to the database."
	super setUp.
	testData := XpfTestData new.
	RestHttpService resource installHandler:
		(XpfRestResourceHttpHandler with: testData testRoot).
	RestHttpService resource installHandler:
		(XpfRestChangesHttpHandler with: testData testRoot).! !

XpfRestTest subclass: #XpfRevisionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server-Rest'!

!XpfRevisionHandlerTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:11'!
testChanges

	| response changes localRevisions |
	localRevisions := Dictionary new
		at: testData testUser restUri put: testData testUser revision;
		at: testData testUser2 restUri put: testData testUser2 revision;
		yourself.
	testData testUser2 login: self class login3.
	response := self post: '/changes' content: (Json render: localRevisions).
	self should: response isOk.
	changes := Json readFrom: response content readStream.
	self should: changes size = 1.
	self should: changes first = testData testUser2 restUri.! !

!XpfRevisionHandlerTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:08'!
testDeletedChanges

	| response changes localRevisions restUri |
	localRevisions := Dictionary new
		at: testData testUser restUri put: testData testUser revision;
		at: testData testUser2 restUri put: testData testUser2 revision;
		yourself.
	restUri := testData testUser2 restUri.
	testData testUser2 delete.
	response := self post: '/changes' content: (Json render: localRevisions).
	self should: response isOk.
	changes := Json readFrom: response content readStream.
	self should: changes size = 1.
	self should: changes first = restUri.! !

!XpfRevisionHandlerTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:08'!
testNoChanges

	| response changes localRevisions |
	localRevisions := Dictionary new
		at: testData testUser restUri put: testData testUser revision;
		at: testData testUser2 restUri put: testData testUser2 revision;
		yourself.
	response := self post: '/changes' content: (Json render: localRevisions).
	self should: response isOk.
	changes := Json readFrom: response content readStream.
	self should: changes isEmpty.! !

TestCase subclass: #XpfClientTestCase
	instanceVariableNames: 'users projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

XpfClientTestCase subclass: #XpfChangePasswordTest
	instanceVariableNames: 'user sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfChangePasswordTest methodsFor: 'running' stamp: 'mt 3/31/2009 14:48'!
setUp

	super setUp.
	user := XpfUser newFrom:
		(Dictionary newFrom:
			{'login' -> 'bernd'.
			'password' -> 'secret'}).
	sut := XpfChangePasswordModel new.	
	sut user: user.! !

!XpfChangePasswordTest methodsFor: 'tests' stamp: 'mt 3/31/2009 14:48'!
testChangePassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta'.
	sut accept.
	self should: (user authenticateBy: 'delta').! !

!XpfChangePasswordTest methodsFor: 'tests' stamp: 'mt 3/31/2009 14:49'!
testInvalidRepeatPassword

	sut newPassword: 'delta'.
	sut newPasswordRepeat: 'delta23'.
	sut accept.
	self
		shouldnt: (user authenticateBy: 'delta');
		shouldnt: (user authenticateBy: 'delta23').! !

XpfClientTestCase subclass: #XpfClientTest
	instanceVariableNames: 'project iteration1 userstory1 userstory2 sut task1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfClientTest methodsFor: 'running' stamp: 'mt 3/31/2009 16:14'!
setUp

	super setUp.
	self setupFixtures.
	sut := XpfClient new model: project.
! !

!XpfClientTest methodsFor: 'running' stamp: 'mt 4/16/2009 16:32'!
setupFixtures

	project := XpfProject new title: 'Test Project'.
	iteration1 := XpfIteration new
		title: 'Sample Iteration'.
	userstory1 := XpfUserStory new
		title: 'Test User Story with long title.'.
	userstory2 := XpfUserStory new title: 'Test User Story'.
	task1 := XpfTask new 
		title: 'Test Task'.
	project addIteration: iteration1.
	iteration1
		addUserStory: userstory1;
		addUserStory: userstory2.
	userstory1 addTask: task1.! !

!XpfClientTest methodsFor: 'running' stamp: 'mt 4/16/2009 11:06'!
tearDown

	userstory1 delete.
	userstory2 delete.
		
	super tearDown.! !

!XpfClientTest methodsFor: 'tests' stamp: 'mt 4/28/2009 15:04'!
testAddTask

	| sut2 taskCount taskMorphCount|
	sut2 := XpfTasksContent forModel: userstory1 tasks.
	taskCount := userstory1 tasks size.
	taskMorphCount :=  sut2 taskList submorphs size.

	self should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph).

	userstory1 addNewTask: (Dictionary newFrom: {'title' -> 'Please enter descr...'}).
	sut2 taskList model: userstory1 tasks.

	self
		should: sut2 taskList submorphs size = (taskMorphCount + 1);
		should: (sut2 taskList submorphs first isKindOf: XpfTaskMorph);
		should: (sut2 taskList submorphs second isKindOf: XpfTaskMorph);
		should: userstory1 tasks size = (taskCount + 1).! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 4/22/2009 15:57'!
testAddUSMorphsToProjectMorph

	| usMorphCount projectMorph |
	projectMorph := XpfUserStoryPoolMorph new.
	usMorphCount := projectMorph userStorySubmorphs size.

	projectMorph addMorph: (XpfUserStoryMorph forUserStory: userstory1).
	self should: projectMorph userStorySubmorphs size = (usMorphCount + 1)! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 3/4/2009 00:32'!
testProjectTitleDisplay

 	self should: sut label = project printString.! !

!XpfClientTest methodsFor: 'tests' stamp: 'topa 4/21/2009 17:10'!
testTitleShouldNotBeTextInModel

	| sut2 oldContent newContent |
	sut2 := XpfUserStoryTitleContent forModel: userstory1.
	sut2 toggleEditMode.
	oldContent := sut2 title getText.
	newContent := Text fromString: 'This is a Text'.

	sut2 title setText: newContent.
	
	self shouldnt: userstory1 title isText.
	
	sut2 title setText: oldContent.
	sut2 toggleEditMode.! !

!XpfClientTestCase class methodsFor: 'testing' stamp: 'mig 4/28/2009 18:05'!
isAbstract

 	^ self = XpfClientTestCase! !

!XpfClientTestCase methodsFor: 'test-helper' stamp: 'mig 4/28/2009 18:04'!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self should: (aTargetObject perform: aSelector) = anObject
		! !

!XpfClientTestCase methodsFor: 'test-helper' stamp: 'mig 4/28/2009 18:04'!
denyAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject
	 that dont behave like plain accessors.
	"
	self
		shouldnt: (aTargetObject perform: aSelector) == anObject
		! !

XpfClientTestCase subclass: #XpfHistoryTest
	instanceVariableNames: 'project userStory task sut iteration root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfHistoryTest methodsFor: 'running' stamp: 'cs 6/3/2009 15:18'!
setUp

	super setUp.
	root := XpfRoot new.
	project := root addNewProject: (Dictionary with: 'title' -> 'bla').
	iteration := project addNewIteration: (Dictionary with: 'title' -> 'testiteration').
	userStory := iteration addNewUserStory: (Dictionary with: 'title' -> 'blub').
	task := userStory addNewTask: (Dictionary with: 'title' -> 'brum').
	sut := XpfHistoryModel new.
	sut project: project.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testAllSelected

	sut showProject: true.
	sut showUserStories: true.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size =
		(project history size +
		userStory history size +
		task history size).! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:13'!
testNothingSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: false.
	self should: sut entries isEmpty.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testProjectSelected

	sut showProject: true.
	sut showUserStories: false.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = project history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:27'!
testTasksSelected

	sut showProject: false.
	sut showUserStories: false.
	sut showTasks: true.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = task history size.! !

!XpfHistoryTest methodsFor: 'tests' stamp: 'cs 4/8/2009 11:28'!
testUserStoriesSelected

	sut showProject: false.
	sut showUserStories: true.
	sut showTasks: false.
	self shouldnt: sut entries isEmpty.
	self should: sut entries size = userStory history size.! !

TestCase subclass: #XpfFixedEndTapeMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfFixedEndTapeMorphTest methodsFor: 'running' stamp: 'mt 10/8/2009 10:25'!
setUp

	super setUp.
	sut := XpfFixedEndTapeMorph new.! !

!XpfFixedEndTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/18/2010 16:11:23.7'!
testProcessModel

	sut addMorph: XpfIterationMorph new.
	self
		should: sut sortedSubmorphs size = 2;
		should: sut contentSubmorphs size = 1;
		should: sut width > sut fixedEndMorphsWidth.
	sut processModel.
	self
		should: sut sortedSubmorphs size = 1;
		should: sut contentSubmorphs size = 0;
		should: sut width = sut fixedEndMorphsWidth.! !

TestCase subclass: #XpfGridMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfGridMorphTest methodsFor: 'running' stamp: 'mt 10/8/2009 15:26'!
setUp

	super setUp.
	sut := XpfGridMorph forMorph: (Morph new extent: 510@510).
	sut parentMorph
		extent: (sut cellWidth @ sut cellHeight) * 10;
		addMorph: sut.
	sut updateExtent.! !

!XpfGridMorphTest methodsFor: 'tests' stamp: 'mt 11/1/2009 17:13'!
testCell

	| morph pm row col |
	pm := sut parentMorph.
	row := 5.
	col := 3.
	morph := Morph new
		extent: (sut cellWidth @ sut cellHeight);
		position: 100@100.
	
	pm addMorph: morph.
	sut fixMorphPosition: morph targetCell: (col @ row).
	
	self
		should: morph left = (sut left + sut margin left + (sut hStep * col) + (sut hSpacing // 2));
		should: morph top = (sut top + sut margin top + (sut vStep * row) + (sut vSpacing // 2));
		should: (sut calculateCell: morph topLeft) = (col @ row).! !

!XpfGridMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 15:27'!
testInitialState

	self
		should: sut rowCount = 9;
		should: sut columnCount = 9.! !

!XpfGridMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 11:15'!
testProposeNewExtent

	self
		should: (sut proposeNewExtent: 50@50) >= (50@50)! !

TestCase subclass: #XpfIterationMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfIterationMorphTest methodsFor: 'support' stamp: 'mt 9/29/2009 15:13'!
checkGridPolicy
	"Extent of sut should be like the grid."

	self
		should: sut topLeft = sut gridMorph topLeft;
		should: sut gridMorph extent = sut extent;
		should: (sut height \\ sut gridMorph vStep) = 0;
		should: (sut width \\ sut gridMorph hStep) = (sut gridMorph margin left + sut gridMorph margin right).! !

!XpfIterationMorphTest methodsFor: 'support' stamp: 'mt 9/29/2009 10:40'!
checkResizeGripPolicy

	self
		should: sut leftSizeGrip topLeft = sut topLeft;
		should: sut leftSizeGrip bottomLeft = sut bottomLeft;
		should: sut rightSizeGrip topRight = sut topRight;
		should: sut rightSizeGrip bottomRight = sut bottomRight.! !

!XpfIterationMorphTest methodsFor: 'support' stamp: 'mt 9/29/2009 10:29'!
clearIteration

	sut hideSupportMorphs.
	sut submorphs do: [:m | m visible ifTrue: [m delete]].
	sut showSupportMorphs.! !

!XpfIterationMorphTest methodsFor: 'running' stamp: 'mt 8/20/2009 12:17'!
setUp

	super setUp.
	sut := XpfIterationMorph new.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 10:44'!
testAddMorph

	| oldExtent |
	oldExtent := sut extent.
	sut
		addMorph: (XpfDraggableCardMorph new position: 0@0);
		addMorph: (XpfDraggableCardMorph new position: 10@10);
		addMorph: (XpfDraggableCardMorph new position: 200@500);
		addMorph: (XpfDraggableCardMorph new position: ((sut top - 100)@(sut right + 200))).
	self
		should: sut extent x >= oldExtent x;
		should: sut extent y >= oldExtent y;
		checkResizeGripPolicy;
		checkGridPolicy.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 11:22'!
testInitialState

	self
		should: sut width = (sut gridMorph hStep + sut leftSizeGrip width + sut rightSizeGrip width);
		checkResizeGripPolicy;
		checkGridPolicy.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 15:14'!
testLayoutInGrid

	| card |
	card := XpfDraggableCardMorph new.
	card model
		positionX: -1;
		positionY: 0.
	sut
		topLeft: 0@0;
		widthGrid: 500.
	self checkGridPolicy.
	
	sut addMorph: card.
	self
		should: sut left < 0;
		should: card left = (sut left + sut gridMorph margin left + (sut gridMorph hSpacing / 2));
		should: sut top = 0; "no resizing vertically"
		should: card top = (sut top + (sut gridMorph vSpacing / 2)).! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 12/1/2009 19:22'!
testLayoutInGridCell

	| card |
	card := XpfDraggableCardMorph new.
	card model
		positionX: 1;
		positionY: 1.
	sut
		topLeft: 0@0;
		widthGrid: 500.
	self checkGridPolicy.
	
	sut addMorph: card.
	self
		should: card left = (sut left + sut gridMorph margin left + sut gridMorph hStep + (sut gridMorph hSpacing // 2));
		should: card top = (sut top + sut gridMorph margin top + sut gridMorph vStep + (sut gridMorph vSpacing // 2)).! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 10:49'!
testMorphExpanding

	| m pos sutPos|
	m := XpfDraggableCardMorph new position: 0@0.
	sut addMorph: m.
	pos := m topLeft.
	sutPos := sut topLeft.
	sut expandToLeft: 10.
	
	self
		should: pos = m topLeft; "unchanged"
		should: pos ~= sut topLeft. "moved"
	! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 15:04'!
testResizingWithSubmorphs

	| card |
	card := XpfDraggableCardMorph new.
	sut widthGrid: 700.	
	sut fitToSubmorphs.
	self
		checkResizeGripPolicy;
		checkGridPolicy.

	sut
		widthGrid: 800;
		addMorph: card;
		fitToSubmorphs.
	self 	
		checkResizeGripPolicy;
		checkGridPolicy;
		should: sut width < (2 * card width);
		should: sut width > (sut leftSizeGrip width + sut rightSizeGrip width).! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 10:30'!
testSupportMorphs

	sut hideSupportMorphs.
	self
		should: (sut submorphs select: [:m | m visible]) isEmpty.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 12/1/2009 19:20'!
testTitleWidth
	"Check whether title is not bigger than the iteration morph."

	self should: sut right >= sut titleLabel right.
	
	sut widthGrid: 50.
	
	self
		should: sut titleLabel width > 0;
		should: sut right >= sut titleLabel right.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 11:24'!
testUpdate

	| w |
	w := sut width.
	sut update: #resized with: {sut leftSizeGrip. 10}.
	self should: sut width > w.
	
	w := sut width.
	sut update: #resized with: {sut leftSizeGrip. w negated}.
	self should: sut width < w.
	
	w := sut width.
	sut update: #resized with: {sut rightSizeGrip. 10}.
	self should: sut width > w.
	
	w := sut width.
	sut update: #resized with: {sut rightSizeGrip. w negated}.
	self should: sut width < w.! !

!XpfIterationMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 11:20'!
testWidthGrid

	sut widthGrid: 0.
	self should: sut width = (sut leftSizeGrip width + sut rightSizeGrip width).
	sut widthGrid: 21.
	self should: sut width > (sut leftSizeGrip width + sut rightSizeGrip width).! !

TestCase subclass: #XpfProjectTapeMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfProjectTapeMorphTest methodsFor: 'running' stamp: 'mt 10/4/2009 15:20'!
setUp

	super setUp.
	sut := XpfProjectTapeMorph new.! !

!XpfProjectTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/18/2010 16:11:36.889'!
testInitialState
	"There is already one iteration morph as the fixed end of the project tape."
	
	| it |
	it := XpfIterationMorph new.
	self
		should: (sut fixedEndMorphs first isKindOf: XpfIterationMorph);
		should: sut width = it width.! !

!XpfProjectTapeMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 10:54'!
testNestedTapes

	| release iteration1 iteration2 |
	iteration1 := XpfIterationMorph new.
	iteration2 := XpfIterationMorph new.

	release := XpfReleaseTapeMorph new.
	release
		addMorph: iteration1;
		addMorph: iteration2.
	
	sut addMorph: release.

	self should: sut width = (release width + sut openStoriesMorph width).
	
	release removeAllSubmorphs.
	
	self
		should: sut left = release left;
		should: sut right = sut openStoriesMorph right;
		should: sut width = (release width + sut openStoriesMorph width).
! !

!XpfProjectTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/19/2010 17:27:07.022'!
testScroller

	| scroller release |
	release := sut addMorph: XpfReleaseTapeMorph new.
	
	sut topLeft: 100@100.
	
	scroller := sut withScrollBar.
	self
		should: sut topLeft = (0@0);
		should: release topLeft = (0@0).! !

TestCase subclass: #XpfReleaseTapeMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfReleaseTapeMorphTest methodsFor: 'running' stamp: 'mt 9/29/2009 11:25'!
setUp

	super setUp.
	sut := XpfReleaseTapeMorph new.! !

!XpfReleaseTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/19/2010 17:14:37.284'!
testInitialState

	self
		should: sut height = XpfTapeMorph tapeHeight;
		should: (sut sortedSubmorphs
			hasEqualElements: {sut openStoriesMorph. sut releaseSeparator});
		should: sut width = (sut releaseSeparator width + sut openStoriesMorph width).
	! !

!XpfReleaseTapeMorphTest methodsFor: 'tests' stamp: 'mt 10/28/2009 18:34'!
testResizeIteration

	| it w |
	it := XpfIterationMorph new.
	sut addMorph: it.
	w := sut width.
	
	it update: #resized with: {it rightSizeGrip. 1}.
	self should: sut width = (w + it gridMorph hStep).! !

!XpfReleaseTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/19/2010 16:38:42.308'!
testSubmorphs
	"Check, whether the separator is always the last submorph."
	
	| w it |
	self
		should: sut sortedSubmorphs first = sut openStoriesMorph;
		should: sut sortedSubmorphs second = sut releaseSeparator;
		should: sut width = (sut openStoriesMorph width + sut releaseSeparator width);
		should: sut fixedEndMorphsWidth = sut width.
		
	w := sut width.
	it := XpfIterationMorph new.
	sut addMorph: it.
	
	self
		should: (sut sortedSubmorphs
			hasEqualElements: {it. sut openStoriesMorph. sut releaseSeparator});
		should: it left = sut left;
		should: it right = sut openStoriesMorph left;
		should: sut width = (w + it width).! !

TestCase subclass: #XpfTapeMorphTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfTapeMorphTest methodsFor: 'running' stamp: 'mt 9/29/2009 15:51'!
setUp

	super setUp.
	sut := XpfTapeMorph new.! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 10/4/2009 15:18'!
testInitialState

	self
		should: sut height = XpfTapeMorph tapeHeight;
		should: sut width = 0;
		should: sut sortedSubmorphs isEmpty;
		should: sut borderWidth = 0.! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 16:10'!
testMixedSubmorphs
	"Mix release tape and iteration morphs."

	| it1 it2 rel |
	it1 := XpfIterationMorph new.
	it2 := XpfIterationMorph new.
	rel := XpfReleaseTapeMorph new.
	sut addMorphs: {rel. it1}.
	rel addMorph: it2.
	self
		should: it2 left = sut left;
		should: rel left = sut left;
		should: it1 left = rel right;
		should: sut width = (rel width + it1 width).! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 10/8/2009 10:29'!
testProcessModel

	sut addMorph: XpfIterationMorph new.
	self
		should: sut sortedSubmorphs size = 1;
		should: sut width > 0.
	sut processModel.
	self
		should: sut sortedSubmorphs size = 0;
		should: sut width = 0.! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 4/18/2010 16:14:07.467'!
testRemoveMorphs

	| it1 it2 rel |
	it1 := XpfIterationMorph new.
	it2 := XpfIterationMorph new.
	rel := XpfReleaseTapeMorph new.
	sut addMorph: rel.
	rel addMorphs: {it1. it2}.
	
	rel removeMorph: it2.
	
	self
		should: it1 right = rel openStoriesMorph left;
		should: sut width = rel width.! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 16:05'!
testScrollBars

	| scroller |
	self
		should: [sut withScrollBar]
		raise: Error.

	sut addMorph: XpfIterationMorph new. "width > 0"
	scroller := sut withScrollBar.
	
	self
		should: (scroller isKindOf: XpfTapeScroller);
		should: scroller scrollTarget = sut.! !

!XpfTapeMorphTest methodsFor: 'tests' stamp: 'mt 9/29/2009 16:06'!
testSubmorphPositions

	| it1 it2 |
	it1 := XpfIterationMorph new.
	it2 := XpfIterationMorph new.
	sut addMorphs: {it1. it2}.
	self
		should: it1 left = sut left;
		should: it2 left = it1 right;
		should: it2 right = sut right;
		should: sut width = (it1 width + it2 width).! !

TestCase subclass: #XpfTapeScrollerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-ProjectTalk'!

!XpfTapeScrollerTest methodsFor: 'running' stamp: 'mt 10/4/2009 15:27'!
setUp

	super setUp.
	sut := XpfTapeMorph new
		addMorph: XpfIterationMorph new;
		withScrollBar.! !

!XpfTapeScrollerTest methodsFor: 'tests' stamp: 'mt 10/4/2009 15:32'!
testAddSubmorphs

	| w |
	w := sut width.
	sut scrollTarget addMorph: XpfIterationMorph new.

	self
		should: sut width = w.! !

!XpfTapeScrollerTest methodsFor: 'tests' stamp: 'mt 10/4/2009 15:28'!
testInitialState

	self
		should: sut width = XpfIterationMorph new width.! !

TestCase subclass: #XpfTestCase
	instanceVariableNames: 'testData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

XpfTestCase subclass: #XpfAuthTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfAuthTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:39'!
testUsuallyAllowed

	self should: (XpfEntity new isMethod: 'METHOD' allowedFor: testData testUser).! !

XpfTestCase subclass: #XpfIterationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfIterationTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:40'!
testAttributes

	self
		checkAccessor: #title on: testData testIteration with: 'Iteration 2';
		checkAccessor: #timeIdeal on: testData testIteration with: 15.
		
! !

!XpfIterationTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:11:47.594'!
testHasUserStories

	| iterationCount usCount us |
	iterationCount := testData testRelease iterations size.
	usCount := testData testIteration userStories size.
	us := testData testIteration addUserStory: XpfUserStory new.
	
	self
		should: testData testIteration userStories size = (usCount + 1)
			description: 'User story count for interation is invalid.';
		should: testData testIteration userStoriesWithDeleted size = (usCount + 1);
		should: testData testRelease iterations size = iterationCount;
		should: (us iteration = testData testIteration).	
	
	us delete.
	self
		should: testData testIteration userStories size = usCount;
		should: testData testIteration userStoriesWithDeleted size = (usCount + 1);		
		should: testData testRelease iterations size = iterationCount.! !

!XpfIterationTest methodsFor: 'running' stamp: 'cs 6/2/2009 18:36'!
testMoveUserStory

	self
		should: testData testIteration2 userStories isEmpty;
		should: testData testIteration userStories first = testData testStory.
	testData testIteration2 addUserStory: testData testStory.
	self
		should: testData testIteration2 userStories first = testData testStory;
		should: testData testIteration userStories isEmpty.! !

!XpfIterationTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:12:08.047'!
testNewAndDelete

	| sut oldCount us |
	sut := XpfIteration new.
	oldCount := testData testRelease iterations size.
	testData testRelease addIteration: sut.
	us := sut addUserStory: XpfUserStory new.
	
	self
		should: testData testRelease iterations size = (oldCount + 1);
		should: (testData testRelease iterations anySatisfy: [:each | each title = sut title]);
		shouldnt: sut isDeleted;
		shouldnt: us isDeleted.

	sut delete.
	self 
		should: testData testRelease iterations size = oldCount;
		should: sut isDeleted;
		should: us isDeleted.! !

!XpfIterationTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:07'!
testNewFrom

	self
		shouldnt: [XpfIteration newFrom: Dictionary new.]
		raise: Error.! !

XpfTestCase subclass: #XpfProjectChooserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Client'!

!XpfProjectChooserTest methodsFor: 'tests' stamp: 'SR 3/10/2009 14:19'!
testChooserDialog

	| liste sut |
	liste := {XpfProject new title:'1'. XpfProject new title: '2'}.
	sut := XpfProjectChooser new.
	sut model projects: liste.
	sut model projectsModel selectionIndex: 1.
	sut okButton performAction.
	
	self
		should: sut result = (liste at: 1).! !

XpfTestCase subclass: #XpfProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfProjectTest methodsFor: 'tests' stamp: 'cs 6/3/2009 15:10'!
testAddExistingUserAsDeveloper

	"Add a user as developer to a project. That user should exist."
	| developerCount userCount developer userId |
	userId := testData testUser2 id.
	developerCount := testData testProject developers size.
	userCount := testData testRoot users size.
	developer := testData testProject addDeveloper: testData testUser2.
	self
		should: testData testUser2 id = userId;
		should: testData testRoot users size = userCount;
		should: testData testProject developers size = (developerCount + 1);
		should: (testData testRoot users includes: developer);
		should: (testData testProject developers includes: developer).
	testData testProject removeDeveloper: developer.
	self
		should: testData testUser2 id = userId;
		should: testData testRoot users size = userCount;
		should: testData testProject developers size = developerCount;
		should: (testData testRoot users includes: developer);
		shouldnt: (testData testProject developers includes: developer).! !

!XpfProjectTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:44'!
testAttributes

	self checkAccessor: #title on: testData testProject with: 'testProject'.! !

!XpfProjectTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:23'!
testAuthentication

	self shouldnt: (testData testProject 
			isMethod: 'GET'
			allowedFor: testData testUser2).
	testData testProject addDeveloper: testData testUser2.
	self should: (testData testProject 
			isMethod: 'GET'
			allowedFor: testData testUser2).
	testData testProject removeDeveloper: testData testUser2.
	self shouldnt: (testData testProject 
			isMethod: 'GET'
			allowedFor: testData testUser2).! !

!XpfProjectTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:24'!
testHasDevelopers

	| developerCount userCount developer |
	developerCount := testData testProject developers size.
	userCount := testData testRoot users size.
	developer := testData testProject addDeveloper: testData testUser2.
	self
		should: testData testUser id notNil;
		should: testData testRoot users size = userCount;
		should: testData testProject developers size = (developerCount + 1);
		should: testData testProject developersWithDeleted size = (developerCount + 1);
		should: (testData testRoot users includes: developer);
		should: (testData testProject developers includes: developer).
	testData testProject removeDeveloper: developer.
	self
		should: testData testRoot users size = userCount;
		should: testData testProject developers size = developerCount;
		should: testData testProject developersWithDeleted size = developerCount;
		should: (testData testRoot users includes: developer);
		shouldnt: (testData testProject developers includes: developer).! !

!XpfProjectTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:47:41.497'!
testHasReleases

	| relCount rel |
	relCount := testData testProject releases size.
	rel := testData testProject addRelease: testData testRelease2.
	self
		should: testData testRelease2 id notNil;
		should: testData testProject releases size = (relCount + 1);
		should: testData testProject releasesWithDeleted size = (relCount + 1).
	rel delete.
	self
		should: testData testProject releases size = relCount;
		should: testData testProject releasesWithDeleted size = (relCount + 1).! !

!XpfProjectTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:50:56.563'!
testNewAndDelete

	| oldCount sut |
	oldCount := testData testRoot projects size.
	sut := XpfProject newFrom: (Dictionary with: 'title' -> 'BlAb').
	testData testRoot addProject: sut.
	sut addRelease: testData testRelease.
		
	self 
		should: testData testRoot projects size = (oldCount + 1) description: 'Project count is not valid for database.';
		should: (testData testRoot projects anySatisfy: [ :each | each title = sut title]);
		shouldnt: sut isDeleted;
		shouldnt: testData testRelease isDeleted.
	
	sut delete.
	self
		should: testData testRoot projects size = oldCount description: 'Project count is not valid for database after deletion.';
		should: sut isDeleted;
		should: testData testRelease isDeleted.! !

!XpfProjectTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:06'!
testNewFrom

	self
		shouldnt: [XpfProject newFrom:
			(Dictionary newFrom: {'title'->'testTitle'})]
		raise: Error.
	self
		should: [XpfProject newFrom: Dictionary new]
		raise: Error.! !

XpfTestCase subclass: #XpfReleaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfReleaseTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:44:01.655'!
testAttributes

	self checkAccessor: #title on: testData testRelease with: 'testRelease'.! !

!XpfReleaseTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:44:41.938'!
testHasIterations

	| iterCount iter |
	iterCount := testData testRelease iterations size.
	iter := testData testRelease addIteration: testData testIteration2.
	self
		should: testData testIteration2 id notNil;
		should: testData testRelease iterations size = (iterCount + 1);
		should: testData testRelease iterationsWithDeleted size = (iterCount + 1).
	iter delete.
	self
		should: testData testRelease iterations size = iterCount;
		should: testData testRelease iterationsWithDeleted size = (iterCount + 1).! !

!XpfReleaseTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:50:21.059'!
testNewAndDelete

	| oldCount sut |
	oldCount := testData testProject releases size.
	sut := XpfRelease newFrom: (Dictionary with: 'title' -> 'BlAb').
	testData testProject addRelease: sut.
	sut addIteration: testData testIteration.
		
	self 
		should: testData testProject releases size = (oldCount + 1) description: 'Release count is not valid for project.';
		should: (testData testProject releases anySatisfy: [ :each | each title = sut title]);
		shouldnt: sut isDeleted;
		shouldnt: testData testIteration isDeleted.
	
	sut delete.
	self
		should: testData testProject releases size = oldCount description: 'Release count is not valid for project after deletion.';
		should: sut isDeleted;
		should: testData testIteration isDeleted.! !

!XpfReleaseTest methodsFor: 'tests' stamp: 'mt 4/15/2010 14:51:35.929'!
testNewFrom

	self
		shouldnt: [XpfRelease newFrom:
			(Dictionary newFrom: {'title'->'testTitle'})]
		raise: Error.! !

XpfTestCase subclass: #XpfRevisionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfRevisionTest methodsFor: 'running' stamp: 'cs 4/24/2009 15:35'!
testHistorySerialization

	| entity parsedEntity |
	entity := XpfProject new.
	entity historyAddEntry: #changed for: #title from: 'foo' to: 'bar'.
	
	parsedEntity := Json readFrom: (Json render: entity history) readStream.
	
	self
		should: (parsedEntity isKindOf: Array);
		should: parsedEntity size = 2.! !

!XpfRevisionTest methodsFor: 'tests' stamp: 'cs 6/2/2009 16:52'!
testRevisionChange

	| oldRevision |
	oldRevision := testData testProject revision.
	testData testProject title: 'brand new title'.
	self should: testData testProject revision = (oldRevision + 1).! !

XpfTestCase subclass: #XpfTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:46'!
testAttributes

	self
		shouldnt: testData testTask isDone;
		checkAccessor: #title on: testData testTask with: 'test task';
		checkAccessor: #timeEstimated on: testData testTask with: 10;
		checkAccessor: #timeActual on: testData testTask with: 12;
		checkAccessor: #isDone on: testData testTask with: true.! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:26'!
testHasDevelopers

	| developer |
	developer := testData testProject addDeveloper:
		(testData testRoot addNewUser: (Dictionary with: 'login' -> 'alice')).
	self should: testData testTask2 developers size = 0.
	testData testStory addTask: testData testTask2.
	testData testTask2 addDeveloper: developer.
	self
		should: testData testTask2 developers size = 1;
		should: testData testTask2 developersWithDeleted size = 1;
		should: (developer tasks includes: testData testTask2).
	testData testTask2 removeDeveloper: developer.
	self
		should: testData testTask2 developers size = 0;
		should: testData testTask2 developersWithDeleted size = 0.! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:48'!
testIntroducedIsDone

	| oldValue |
	oldValue := testData testTask isDone.
	"this is the case in Old objects"
	testData testTask isDone: nil.
	
	self should: testData testTask isDone not.	! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:12'!
testNewAndDelete

	| oldCount |
	oldCount := testData testStory tasks size.

	testData testStory addTask: testData testTask2.
	self
		should: testData testStory tasks size = (oldCount + 1);
		should: (testData testStory tasks anySatisfy: [:each | each title = testData testTask title]);
		should: testData testTask2 userStory = testData testStory;
		shouldnt: testData testTask2 isDeleted.

	testData testTask2 delete.
	self
		should: testData testStory tasks size = oldCount;
		should: testData testTask2 userStory = testData testStory;
		should: testData testTask2 isDeleted.! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:07'!
testNewFrom

	self
		shouldnt: [XpfTask newFrom: Dictionary new.]
		raise: Error.! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:14'!
testStartWork

	self
		shouldnt: testData testTask2 isStarted;
		should: testData testTask2 lastStarted isNil;
		should: testData testTask2 timeActual isNil.	
	testData testTask2 isStarted: true.
	self
		should: testData testTask2 isStarted;
		should: testData testTask2 lastStarted notNil;
		should: testData testTask2 timeActual notNil.	! !

!XpfTaskTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:49'!
testStopWork

	testData testTask
		isStarted: true;
		isStarted: false.
	self
		shouldnt: testData testTask isStarted;
		shouldnt: testData testTask lastStarted isNil;
		shouldnt: testData testTask timeActual isNil.! !

!XpfTestCase class methodsFor: 'testing' stamp: 'topa 3/3/2009 18:42'!
isAbstract

 	^ self name = #XpfTestCase! !

!XpfTestCase methodsFor: 'test-helper' stamp: 'mt 4/6/2009 17:13'!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self should: (aTargetObject perform: aSelector) = anObject
		! !

!XpfTestCase methodsFor: 'test-helper' stamp: 'topa 2/12/2009 14:03'!
denyAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject
	 that dont behave like plain accessors.
	"
	self
		shouldnt: (aTargetObject perform: aSelector) == anObject
		! !

!XpfTestCase methodsFor: 'running' stamp: 'cs 6/2/2009 16:38'!
setUp

	super setUp.
	testData := XpfTestData new.! !

XpfTestCase subclass: #XpfUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:49'!
testAttributes

	self
		checkAccessor: #title on: testData testStory with: 'US + Tasks verwalten';
		checkAccessor: #priority on: testData testStory with: 5;
		checkAccessor: #timeEstimated on: testData testStory  with: 10;
		checkAccessor: #timeActual on: testData testStory  with: 12. 
		
! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:09'!
testHasTasks

	| task |
	self should: testData testStory2 tasks size = 0.
	task := testData testStory2 addTask: XpfTask new. 
	self 
		should: testData testStory2 tasks size = 1 description: 'Task count for user story is invalid.';
		should: testData testStory2 tasksWithDeleted size = 1;
		should: task userStory = testData testStory2;
		shouldnt: task isDeleted.	
	task delete.
	self
		should: testData testStory2 tasks size = 0;
		should: testData testStory2 tasksWithDeleted size = 1;
		should: task isDeleted.
	testData testStory2 delete.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:50'!
testHistoryInitial

	self should: testData testStory history size = 5.
	self should: testData testStory history first action = #created.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:59'!
testMoveTask

	self
		should: testData testStory tasks first = testData testTask;
		should: testData testStory2 tasks isEmpty.
	testData testStory2 addTask: testData testTask.
	self
		should: testData testStory tasks isEmpty;
		should: testData testStory2 tasks first = testData testTask.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:03'!
testNewAndDelete

	| oldCount task |
	oldCount := testData testIteration userStories size.
	testData testIteration addUserStory: testData testStory2.
	task := testData testStory2 addTask: XpfTask new.
	
	self
		should: testData testIteration userStories size = (oldCount + 1);
		should: (testData testIteration userStories anySatisfy: [:each | each title = testData testStory2 title]);
		shouldnt: testData testStory2 isDeleted;
		shouldnt: task isDeleted.

	testData testStory2 delete.
	self 
		should: testData testIteration userStories size = oldCount;
		should: testData testStory2 isDeleted;
		should: task isDeleted.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:07'!
testNewFrom

	self
		shouldnt: [XpfUserStory newFrom: Dictionary new.]
		raise: Error.! !

!XpfUserStoryTest methodsFor: 'tests' stamp: 'mt 11/1/2009 19:02'!
testPosition

	testData testStory position: 20@30.
	self
		should: testData testStory position = (20@30);
		should: (Json readFrom: (Json render: testData testStory position) readStream) = (20@30).! !

XpfTestCase subclass: #XpfUserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Tests-Server'!

!XpfUserTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 22:59'!
login

	^ 'test.user'! !

!XpfUserTest class methodsFor: 'fixture-data' stamp: 'topa 3/3/2009 22:59'!
password

	^ 'TEST'! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:07'!
testAddExistingProjectToUser

	"Add a project to the user. That project should exist."
	| projectCount globalProjectCount |
	projectCount := testData testUser2 projects size.
	globalProjectCount := testData testRoot projects size.
	testData testUser2 addProject: testData testProject.
	self
		should: testData testRoot projects size = globalProjectCount;
		should: testData testUser2 projects size = (projectCount + 1);
		should: (testData testRoot projects includes: testData testProject);
		should: (testData testUser2 projects includes: testData testProject).
	testData testUser2 removeProject: testData testProject.
	self
		should: testData testRoot projects size = globalProjectCount;
		should: testData testUser2 projects size = projectCount;
		should: (testData testRoot projects includes: testData testProject);
		shouldnt: (testData testUser2 projects includes: testData testProject).! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 17:55'!
testAttributes

	self
		checkAccessor: #login on: testData testUser with: 'marcel.taeumel';
		checkAccessor: #userName on: testData testUser with: 'Marcel Taeumel';
		checkAccessor: #email on: testData testUser with: 'marcel.taeumel@student.hpi.uni-potsdam.de'.! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 19:05'!
testHasProjects

	| projectCount globalProjectCount |
	projectCount := testData testUser2 projects size.
	globalProjectCount := testData testRoot projects size.
	testData testUser2 addProject: testData testProject.
	self
		should: testData testProject id notNil;
		should: testData testRoot projects size = globalProjectCount;
		should: testData testUser2 projects size = (projectCount + 1);
		should: testData testUser2 projectsWithDeleted size = (projectCount + 1);
		should: (testData testRoot projects includes: testData testProject);
		should: (testData testUser2 projects includes: testData testProject).
	testData testUser2 removeProject: testData testProject.
	self
		should: testData testRoot projects size = globalProjectCount;
		should: testData testUser2 projects size = projectCount;
		should: testData testUser2 projectsWithDeleted size = projectCount;
		should: (testData testRoot projects includes: testData testProject);
		shouldnt: (testData testUser2 projects includes: testData testProject).! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:57'!
testNewAndDelete

	| oldCount sut |
	sut := XpfUser newFrom: (Dictionary with: 'login' -> 'blbla').
	oldCount := testData testRoot users size.	
	self shouldnt: (testData testRoot users anySatisfy: [ :each | each login = sut login]).

	testData testRoot addUser: sut.
	self 
		should: testData testRoot users size = (oldCount + 1);
		should: (testData testRoot users anySatisfy: [ :each | each login = sut login]);
		shouldnt: sut isDeleted.
	
	sut delete.
	self
		should: testData testRoot users size = oldCount;
		should: sut isDeleted.! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:04'!
testNewFrom

	self
		shouldnt: [XpfUser newFrom:
			(Dictionary newFrom: {'login'->'test@example.com'})]
		raise: Error.
	self
		should: [XpfUser newFrom: Dictionary new]
		raise: Error.! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:21'!
testPasswordHashing

	self
		should: testData testUser password = nil;
		should: (testData testUser authenticateBy: RestTest password);
		shouldnt: (testData testUser authenticateBy: RestTest password , 'NOT').! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:21'!
testUserAuthenticationFail

	self
		should: (testData testRoot
			authenticate: RestTest login
			by: RestTest password , 'NOT') isNil;
		should: (testData testRoot
			authenticate: RestTest login, 'NOT'
			by: RestTest password) isNil;
		should: (testData testRoot
			authenticate: RestTest login, 'NOT'
			by: RestTest password , 'NOT') isNil.! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:22'!
testUserAuthenticationSuccess

	self should: testData testUser =
		(testData testRoot
			authenticate: RestTest login
			by: RestTest password).! !

!XpfUserTest methodsFor: 'tests' stamp: 'cs 6/2/2009 18:11'!
testUserIsOnline

	| t1 t2 t3 |
	t1 := TimeStamp now.
	t2 := t1 - 5 seconds.
	t3 := t1 - 15 seconds.
	
	testData testUser lastAccess: t2.
	self 	should: testData testUser isOnline.
		
	testData testUser lastAccess: t3.
	self shouldnt: testData testUser isOnline.! !
